﻿module AdditionalConstructors

//====================================================
// Подробное описание программного кода исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================


type AddConstructor(p1: int, p2: int) as this = 
    // --- Тело первичного конструктора ---
    let pc = printfn $"\nЯ первичный конструктор! Параметры: p1=%d{p1}; p2=%d{p2}"  
    do
        printfn "do-привязка первичного конструктора"

    // --- Тело первичного конструктора ---

    new(x: int) as this2 = 
        let mult1 = 9 * 7
        let mult2 = 9 * 8
        AddConstructor(mult1, mult2) then
            printfn "Я второй конструктор. Параметр: %d" x
            // xx let letprimaryconstructor = p2
            let d = this2.Member
            d |> ignore

    new(str: string) = 
        AddConstructor(3, 4) then
            printfn "Я третий конструктор. Параметр: %s" str

    new(str: string, i: int) = 
        AddConstructor(5, 6) then
            printfn "Я четвёртый конструктор. Параметры: %s, %d" str i

    new() = 
        AddConstructor(7, 8) then
            printfn "Я пятый конструктор. Параметры отсутствуют."

    member d.Member = 89