﻿module OptionalParameters

//====================================================
// Подробное описание программного кода исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================

type ClassParameter(?name: string, ?price: float) =
    let mutable n = defaultArg name "без названия"
    let mutable p= defaultArg price 0.0
    

    member x.Info = 
        if p > 0 then
            printfn $"Название компонента: %s{n}, стоимость %f{p}"
        else
            printfn "Компонент отсутствует"


type ClassParameters2(?speed: int, ?weight: int, ?color: string) = 
    let s = if speed.IsSome = false then 0 else speed.Value
    let w = defaultArg weight 0
    let c = defaultArg color "нет данных"

    member x.Info = 
        let speed = if s = 0 then "нет данных" else s.ToString()
        let weight =  if w = 0 then "Нет данных" else w.ToString()
        
        printfn "Характеристика автомобиля:"
        printfn "Скорость - %s" speed
        printfn "Вес - %s" weight
        printfn "Цвет - %s" c
    