﻿module PrimaryConstructors

//====================================================
// Подробное описание программного кода исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================


// Таблица умножения 
type MultiplicationTable() = 
    class
        // --- Код первичного конструктора ---
        let res = 
            for n = 1 to 9 do
                for m = 1 to 9 do
                    printf "%dx%d=%d\t" m n (m*n)
                printfn""
            printfn""
        // --- /Код первичного конструктора ---

        member this.Exponentiation x y = x ** y
    end



// Умножение данного числа на данный диапазон чисел
type MultiplicationRange(num: int, maxmultiplier: int) as self = 
    static let mutable staticlet = 230

    // --- Код первичного конструктора ---
    let check = 
        if maxmultiplier > 100 
        then 100 
        else maxmultiplier
    do
        for m = 1 to check do
            printfn $"%d{num}x%d{m}=%d{(m*num)}"
    do
        self.Message
        self.ViewStaticLet
    // --- /Код первичного конструктора ---

    member this.Message = 
        printfn "Максимальный множитель = %d" check
    member this.ViewStaticLet = 
        printfn "Значение статического поля staticlet= %d" staticlet

    static member StaticProperty
            with get () = staticlet
            and set (value) = staticlet <- value

    static member StaticFunction = 45 + staticlet


